module QueryInterface
  module Server
    module Resource

      def self.for(model)
        Module.new do
          define_singleton_method(:included) do |base|
            base.send(:define_method, :query_model) { model }
          end
          include InstanceMethods
        end
      end

      module InstanceMethods
        def query
          transformer = Transformations::SequelTransformer.new(self.query_model.filter)
          transformations = params[:transformations] || []
          transformations = JSON.parse(transformations) unless transformations.is_a?(Array)
          result = transformer.run(transformations)
          unless result.nil?
            respond_to do |format|
              format.json { render json: result }
            end
          else
            head :not_found
          end
        end
      end
    end
  end
end
